// simplified trimesh for making circle meshes

#ifndef TRIMESH_H
#define TRIMESH_H

typedef struct{
   int nv; // number of vertices
   int nt; // number of triangles
   float *x; // 3*nv array of vertices
   int *tri; // 3*nt array of triangle indices
   int *deg; // nv array of degree of each vertex
   int **adj; // nv array of arrays of the adjacencies (adj[i][j] is the j'th neighbour of vertex i)
   char *bdry; // nv array indicating whether vertices are on the boundary or not
} TriMesh;

void read_tri_mesh(const char *filename, TriMesh *mesh);
void write_tri_mesh(const char *filename, TriMesh *mesh);
void compute_adjacencies(TriMesh *mesh);

#endif
