#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "cloth.h"

void make_cloth(Cloth *cloth, float density, float planar_youngs, float planar_damping, float max_strain,
                float bending_resistance, float bending_damping)
{
   int i, nv=cloth->mesh.nv, nt=cloth->mesh.nt, ne=cloth->mesh.ne, nb=cloth->mesh.nb;

   cloth->m=(float*)calloc(nv, sizeof(float));
   cloth->v=(float*)calloc(3*nv, sizeof(float));
   cloth->k=(float*)calloc(ne, sizeof(float));
   cloth->L=(float*)calloc(ne, sizeof(float));
   cloth->d=(float*)calloc(ne, sizeof(float));
   cloth->max_strain=max_strain;
   cloth->kbend=(float*)calloc(nb, sizeof(float));
   cloth->restbend=(float*)calloc(nb, sizeof(float));
   cloth->dbend=(float*)calloc(nb, sizeof(float));

   // @@@ need to fill in code to compute m, k, L, d, kbend, and dbend
   // recall that
   //  m[i] is the density times 1/3 of the sum of the areas of the triangles incident on i
   //  k[e] is planar_youngs*(mass around spring)/(L[e]*density)
   //  mass around a spring is the density times 1/3 of the sum of the areas of the triangles incident on the edge
   //  L[e] is the rest length of the spring, which is just the length of the edge from mesh->x[]
   //  d[e] is the same as k[e] with planar_damping replacing planar_youngs
   //  kbend[q] is bending_resistance*(edge length)^2/(sum of triangle areas)
   //  restbend[q] is sin(theta_0/2) for the bending element with positions given by mesh->x[]
   //  dbend[q] is bending_damping*(edge length)
   // Finally, you can leave v as is -- zero velocity
}

float max_time_step(const Cloth *cloth)
{
   // @@@ need to fill in code here to get a lower bound on the maximum stable time step for Symplectic Euler
}

void add_forces(const Cloth *cloth, const float *x, const float *v, float *f)
{
   add_elastic_spring_forces(cloth, x, f);
   add_damping_spring_forces(cloth, x, v, f);
   add_elastic_bending_forces(cloth, x, f);
   add_damping_bending_forces(cloth, x, v, f);
}

void add_elastic_spring_forces(const Cloth *cloth, const float *x, float *f)
{
   // @@@ need to fill in code here to add the elastic part of the spring forces, assuming the
   // particles are currently in positions x. Add the forces to f.
}

void add_damping_spring_forces(const Cloth *cloth, const float *x, const float *v, float *f)
{
   // @@@ need to fill in code here to add the damping part of the spring forces, assuming the
   // particles are currently in positions x and moving with velocities v. Add the forces to f.
}

void add_elastic_bending_forces(const Cloth *cloth, const float *x, float *f)
{
   // @@@ need to fill in code here to add the elastic part of the bending forces, assuming the
   // particles are currently in positions x. Add the forces to f.
}

void add_damping_bending_forces(const Cloth *cloth, const float *x, const float *v, float *f)
{
   // @@@ need to fill in code here to add the damping part of the bending forces, assuming the
   // particles are currently in positions x and moving with velocities v. Add the forces to f.
}

void limit_strain(const Cloth *cloth, float dt, float *x, float *v)
{
   // @@@ need to fill in code here to loop through all of the edges e looking for those that have
   // extended to more than (1+max_strain)*L[e] in length (given the current positions in x).
   // As soon as one is found, find the impulse J in the direction of the edge that would reduce the
   // length to just under the max length, say (0.9999+max_strain)*L[e], over the time step dt.
   // Update x and v of the endpoints accordingly, then move on to the next edge.
}

