#ifndef TRIMESH_H
#define TRIMESH_H

typedef struct{
   int nv; // number of vertices
   int ne; // number of edges
   int nt; // number of triangles
   int nb; // number of bending elements (adjacent triangle pairs)
   float *x; // 3*nv array of vertices
   int *tri; // 3*nt array of triangle indices
   int *edge; // 2*ne array of edge indices
   int *bend; // 4*nb array of bending element indices
} TriMesh;

void read_tri_mesh(const char *filename, TriMesh *mesh);
void write_tri_mesh(const char *filename, TriMesh *mesh);
void compute_auxiliary_structures(TriMesh *mesh);

#endif
