#ifndef TRIMESH_H
#define TRIMESH_H

typedef struct{
   int nv; // number of vertices
   int nt; // number of triangles
   float *x; // 3*nv array of vertices
   int *tri; // 3*nt array of triangle indices
   float *vnormals; // 3*nv array of vertex normals (if not 0)
} TriMesh;

void read_tri_mesh(const char *filename, TriMesh *mesh);
void write_tri_mesh(const char *filename, TriMesh *mesh);
void compute_vertex_normals(TriMesh *mesh);

#endif
